/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.96 Revision 1.143
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2014 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.96 2011/06/06 21:38:18 abcd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.143 2014/11/13 04:19:51 kensington Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed 13# NOTE: KDE 4 ebuilds currently support EAPIs 4 and 5. This will be
14# over time as new EAPI versions are approved. 14# reviewed over time as new EAPI versions are approved.
15
16if [[ -z ${_KDE4_BASE_ECLASS} ]]; then
17_KDE4_BASE_ECLASS=1
18
19# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
20# @DESCRIPTION:
21# If set to "none", do nothing.
22# For any other value, add selinux to IUSE, and depending on that useflag
23# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
24: ${KDE_SELINUX_MODULE:=none}
25
26# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
27# @DESCRIPTION:
28# If defined, launch and use a private dbus session during src_test.
15 29
16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED 30# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION: 31# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage. 32# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx 33# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test. 34# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual} 35: ${VIRTUALX_REQUIRED:=manual}
22 36
23inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils 37inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils virtualx versionator eutils multilib
24 38
25if [[ ${BUILD_TYPE} = live ]]; then 39if [[ ${KDE_BUILD_TYPE} = live ]]; then
26 case ${KDE_SCM} in 40 case ${KDE_SCM} in
27 svn) inherit subversion ;; 41 svn) inherit subversion ;;
28 git) inherit git-2 ;; 42 git) inherit git-r3 ;;
29 esac 43 esac
30fi 44fi
31 45
32# @ECLASS-VARIABLE: CMAKE_REQUIRED 46# @ECLASS-VARIABLE: CMAKE_REQUIRED
33# @DESCRIPTION: 47# @DESCRIPTION:
39if [[ ${CMAKE_REQUIRED} = always ]]; then 53if [[ ${CMAKE_REQUIRED} = always ]]; then
40 buildsystem_eclass="cmake-utils" 54 buildsystem_eclass="cmake-utils"
41 export_fns="src_configure src_compile src_test src_install" 55 export_fns="src_configure src_compile src_test src_install"
42fi 56fi
43 57
44# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
45if [[ -n ${KDE_MINIMAL} ]]; then
46 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
47 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
48 done
49 unset slot
50 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
51else
52 KDE_MINIMAL_VALID=1
53fi
54
55# @ECLASS-VARIABLE: KDE_MINIMAL 58# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION: 59# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal 60# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4 61# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements. 62# One may override this variable to raise version requirements.
60# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
61# Note that it is fixed to ${SLOT} for kde-base packages. 63# Note that it is fixed to ${PV} for kde-base packages.
62KDE_MINIMAL="${KDE_MINIMAL:-4.4}" 64KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
63 65
64# Set slot for KDEBASE known packages 66# Set slot for KDEBASE known packages
65case ${KDEBASE} in 67case ${KDEBASE} in
66 kde-base) 68 kde-base)
67 SLOT=$(_calculate_kde_slot) 69 case ${EAPI} in
68 [[ -z ${SLOT} ]] && die "Unsupported ${PV}" 70 5)
71 SLOT=4/$(get_version_component_range 1-2)
72 ;;
73 *)
74 SLOT=4
75 ;;
76 esac
69 KDE_MINIMAL="${SLOT}" 77 KDE_MINIMAL="${PV}"
70 ;;
71 koffice)
72 SLOT="2"
73 ;; 78 ;;
74 kdevelop) 79 kdevelop)
75 if [[ ${BUILD_TYPE} = live ]]; then 80 if [[ ${KDE_BUILD_TYPE} = live ]]; then
76 # @ECLASS-VARIABLE: KDEVELOP_VERSION 81 # @ECLASS-VARIABLE: KDEVELOP_VERSION
77 # @DESCRIPTION: 82 # @DESCRIPTION:
78 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages. 83 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
79 # Applies to KDEBASE=kdevelop only. 84 # Applies to KDEBASE=kdevelop only.
80 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}" 85 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.9999}"
81 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION 86 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
82 # @DESCRIPTION: 87 # @DESCRIPTION:
83 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages. 88 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
84 # Applies to KDEBASE=kdevelop only. 89 # Applies to KDEBASE=kdevelop only.
85 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}" 90 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-4.9999}"
86 else 91 else
87 case ${PN} in 92 case ${PN} in
88 kdevelop|quanta) 93 kdevelop)
89 KDEVELOP_VERSION=${PV} 94 KDEVELOP_VERSION=${PV}
90 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)" 95 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
91 ;; 96 ;;
92 kdevplatform) 97 kdevplatform|kdevelop-php*|kdevelop-python)
93 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)" 98 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
94 KDEVPLATFORM_VERSION=${PV} 99 KDEVPLATFORM_VERSION=${PV}
95 ;; 100 ;;
96 *) 101 *)
97 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}" 102 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
109unset buildsystem_eclass 114unset buildsystem_eclass
110unset export_fns 115unset export_fns
111 116
112# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED 117# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
113# @DESCRIPTION: 118# @DESCRIPTION:
114# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'. 119# Is qtdeclarative required? Possible values are 'always', 'optional' and 'never'.
115# This variable must be set before inheriting any eclasses. Defaults to 'never'. 120# This variable must be set before inheriting any eclasses. Defaults to 'never'.
116DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}" 121DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
117 122
118# @ECLASS-VARIABLE: QTHELP_REQUIRED 123# @ECLASS-VARIABLE: QTHELP_REQUIRED
119# @DESCRIPTION: 124# @DESCRIPTION:
120# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'. 125# Is qthelp required? Possible values are 'always', 'optional' and 'never'.
121# This variable must be set before inheriting any eclasses. Defaults to 'never'. 126# This variable must be set before inheriting any eclasses. Defaults to 'never'.
122QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}" 127QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
123 128
124# @ECLASS-VARIABLE: OPENGL_REQUIRED 129# @ECLASS-VARIABLE: OPENGL_REQUIRED
125# @DESCRIPTION: 130# @DESCRIPTION:
126# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 131# Is qtopengl required? Possible values are 'always', 'optional' and 'never'.
127# This variable must be set before inheriting any eclasses. Defaults to 'never'. 132# This variable must be set before inheriting any eclasses. Defaults to 'never'.
128OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 133OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
129 134
130# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED 135# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
131# @DESCRIPTION: 136# @DESCRIPTION:
132# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'. 137# Is qtmultimedia required? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'never'. 138# This variable must be set before inheriting any eclasses. Defaults to 'never'.
134MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}" 139MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
135 140
136# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 141# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
137# @DESCRIPTION: 142# @DESCRIPTION:
159# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE 164# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
160# @DESCRIPTION: 165# @DESCRIPTION:
161# Set this varible if you want your live package to manage its 166# Set this varible if you want your live package to manage its
162# translations. (Mostly all kde ebuilds does not ship documentation 167# translations. (Mostly all kde ebuilds does not ship documentation
163# and translations in live ebuilds) 168# and translations in live ebuilds)
164if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then 169if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
165 # Kdebase actualy provides the handbooks even for live stuff 170 # Kdebase actualy provides the handbooks even for live stuff
166 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never 171 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
167 KDE_LINGUAS="" 172 KDE_LINGUAS=""
168fi 173fi
169 174
170# Setup packages inheriting this eclass 175# Setup packages inheriting this eclass
171case ${KDEBASE} in 176case ${KDEBASE} in
172 kde-base) 177 kde-base)
173 HOMEPAGE="http://www.kde.org/" 178 HOMEPAGE="http://www.kde.org/"
174 LICENSE="GPL-2" 179 LICENSE="GPL-2"
175 if [[ $BUILD_TYPE = live ]]; then 180 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
176 # Disable tests for live ebuilds 181 # Disable tests for live ebuilds by default
177 RESTRICT+=" test" 182 RESTRICT+=" test"
178 fi
179
180 # Only add the kdeprefix USE flag for older versions, to help
181 # non-portage package managers handle the upgrade
182 if [[ ${PV} < 4.6.4 ]]; then
183 IUSE+=" kdeprefix"
184 fi 183 fi
185 184
186 # This code is to prevent portage from searching GENTOO_MIRRORS for 185 # This code is to prevent portage from searching GENTOO_MIRRORS for
187 # packages that will never be mirrored. (As they only will ever be in 186 # packages that will never be mirrored. (As they only will ever be in
188 # the overlay). 187 # the overlay).
189 case ${PV} in 188 case ${PV} in
190 *9999* | 4.?.[6-9]?) 189 *9999* | 4.?.[6-9]? | 4.??.[6-9]?)
191 RESTRICT+=" mirror" 190 RESTRICT+=" mirror"
192 ;; 191 ;;
193 esac 192 esac
194 # Block installation of other SLOTS unless kdeprefix
195 RDEPEND+=" $(block_other_slots)"
196 ;;
197 koffice)
198 HOMEPAGE="http://www.koffice.org/"
199 LICENSE="GPL-2"
200 ;; 193 ;;
201 kdevelop) 194 kdevelop)
202 HOMEPAGE="http://www.kdevelop.org/" 195 HOMEPAGE="http://www.kdevelop.org/"
203 LICENSE="GPL-2" 196 LICENSE="GPL-2"
204 ;; 197 ;;
205esac 198esac
206 199
207# @ECLASS-VARIABLE: QT_MINIMAL 200# @ECLASS-VARIABLE: QT_MINIMAL
208# @DESCRIPTION: 201# @DESCRIPTION:
209# Determine version of qt we enforce as minimal for the package. 202# Determine version of qt we enforce as minimal for the package.
210if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then
211 QT_MINIMAL="${QT_MINIMAL:-4.7.0}" 203QT_MINIMAL="${QT_MINIMAL:-4.8.5}"
212else
213 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
214fi
215 204
216# Declarative dependencies 205# Declarative dependencies
217qtdeclarativedepend=" 206qtdeclarativedepend="
218 >=x11-libs/qt-declarative-${QT_MINIMAL}:4 207 >=dev-qt/qtdeclarative-${QT_MINIMAL}:4
219" 208"
220case ${DECLARATIVE_REQUIRED} in 209case ${DECLARATIVE_REQUIRED} in
221 always) 210 always)
222 COMMONDEPEND+=" ${qtdeclarativedepend}" 211 COMMONDEPEND+=" ${qtdeclarativedepend}"
223 ;; 212 ;;
229esac 218esac
230unset qtdeclarativedepend 219unset qtdeclarativedepend
231 220
232# QtHelp dependencies 221# QtHelp dependencies
233qthelpdepend=" 222qthelpdepend="
234 >=x11-libs/qt-assistant-${QT_MINIMAL}:4 223 >=dev-qt/qthelp-${QT_MINIMAL}:4
235" 224"
236case ${QTHELP_REQUIRED} in 225case ${QTHELP_REQUIRED} in
237 always) 226 always)
238 COMMONDEPEND+=" ${qthelpdepend}" 227 COMMONDEPEND+=" ${qthelpdepend}"
239 ;; 228 ;;
244esac 233esac
245unset qthelpdepend 234unset qthelpdepend
246 235
247# OpenGL dependencies 236# OpenGL dependencies
248qtopengldepend=" 237qtopengldepend="
249 >=x11-libs/qt-opengl-${QT_MINIMAL}:4 238 >=dev-qt/qtopengl-${QT_MINIMAL}:4
250" 239"
251case ${OPENGL_REQUIRED} in 240case ${OPENGL_REQUIRED} in
252 always) 241 always)
253 COMMONDEPEND+=" ${qtopengldepend}" 242 COMMONDEPEND+=" ${qtopengldepend}"
254 ;; 243 ;;
260esac 249esac
261unset qtopengldepend 250unset qtopengldepend
262 251
263# MultiMedia dependencies 252# MultiMedia dependencies
264qtmultimediadepend=" 253qtmultimediadepend="
265 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4 254 >=dev-qt/qtmultimedia-${QT_MINIMAL}:4
266" 255"
267case ${MULTIMEDIA_REQUIRED} in 256case ${MULTIMEDIA_REQUIRED} in
268 always) 257 always)
269 COMMONDEPEND+=" ${qtmultimediadepend}" 258 COMMONDEPEND+=" ${qtmultimediadepend}"
270 ;; 259 ;;
290 ;; 279 ;;
291 *) ;; 280 *) ;;
292esac 281esac
293unset cppuintdepend 282unset cppuintdepend
294 283
295
296# WebKit use dependencies
297case ${KDE_REQUIRED} in
298 always)
299 qtwebkitusedeps="[kde]"
300 ;;
301 optional)
302 qtwebkitusedeps="[kde?]"
303 ;;
304 *) ;;
305esac
306# KDE dependencies 284# KDE dependencies
307# Qt accessibility classes are needed in various places, bug 325461 285# Qt accessibility classes are needed in various places, bug 325461
308kdecommondepend=" 286kdecommondepend="
309 dev-lang/perl 287 dev-lang/perl
288 >=dev-qt/qt3support-${QT_MINIMAL}:4[accessibility]
310 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 289 >=dev-qt/qtcore-${QT_MINIMAL}:4[qt3support,ssl]
290 >=dev-qt/qtdbus-${QT_MINIMAL}:4
291 >=dev-qt/designer-${QT_MINIMAL}:4[-phonon]
311 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 292 >=dev-qt/qtgui-${QT_MINIMAL}:4[accessibility,dbus(+)]
312 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
313 >=x11-libs/qt-script-${QT_MINIMAL}:4 293 >=dev-qt/qtscript-${QT_MINIMAL}:4
314 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 294 >=dev-qt/qtsql-${QT_MINIMAL}:4[qt3support]
315 >=x11-libs/qt-svg-${QT_MINIMAL}:4 295 >=dev-qt/qtsvg-${QT_MINIMAL}:4
316 >=x11-libs/qt-test-${QT_MINIMAL}:4 296 >=dev-qt/qttest-${QT_MINIMAL}:4
317 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps} 297 >=dev-qt/qtwebkit-${QT_MINIMAL}:4
318 !aqua? (
319 x11-libs/libXext
320 x11-libs/libXt
321 x11-libs/libXxf86vm
322 x11-libs/libXcomposite
323 )
324" 298"
325 299
326if [[ ${PN} != kdelibs ]]; then 300if [[ ${PN} != kdelibs ]]; then
327 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 301 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
328 if [[ ${KDEBASE} = kdevelop ]]; then 302 if [[ ${KDEBASE} = kdevelop ]]; then
333 # Applies to KDEBASE=kdevelop only. 307 # Applies to KDEBASE=kdevelop only.
334 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}" 308 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
335 case ${KDEVPLATFORM_REQUIRED} in 309 case ${KDEVPLATFORM_REQUIRED} in
336 always) 310 always)
337 kdecommondepend+=" 311 kdecommondepend+="
338 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION} 312 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}:4
339 " 313 "
340 ;; 314 ;;
341 *) ;; 315 *) ;;
342 esac 316 esac
343 fi 317 fi
344 fi 318 fi
345fi 319fi
346 320
347kdedepend=" 321kdedepend="
348 dev-util/automoc 322 dev-util/automoc
349 dev-util/pkgconfig 323 virtual/pkgconfig
350 !aqua? ( 324 !aqua? (
351 >=x11-libs/libXtst-1.1.0 325 >=x11-libs/libXtst-1.1.0
352 x11-proto/xf86vidmodeproto 326 x11-proto/xf86vidmodeproto
353 ) 327 )
354" 328"
358# all packages needs oxygen icons for basic iconset 332# all packages needs oxygen icons for basic iconset
359if [[ ${PN} != oxygen-icons ]]; then 333if [[ ${PN} != oxygen-icons ]]; then
360 kderdepend+=" $(add_kdebase_dep oxygen-icons)" 334 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
361fi 335fi
362 336
363# add a dependency over kde-l10n if EAPI4 or better is around 337# add a dependency over kde-l10n
364if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then 338if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} ]]; then
365 for _lingua in ${KDE_LINGUAS}; do 339 for _lingua in ${KDE_LINGUAS}; do
366 # if our package has lignuas, pull in kde-l10n with selected lingua enabled, 340 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
367 # but only for selected ones. 341 # but only for selected ones.
368 # this can't be done on one line because if user doesn't use any localisation 342 # this can't be done on one line because if user doesn't use any localisation
369 # then he is probably not interested in kde-l10n at all. 343 # then he is probably not interested in kde-l10n at all.
393 ;; 367 ;;
394 *) ;; 368 *) ;;
395esac 369esac
396unset kdehandbookdepend kdehandbookrdepend 370unset kdehandbookdepend kdehandbookrdepend
397 371
372case ${KDE_SELINUX_MODULE} in
373 none) ;;
374 *)
375 IUSE+=" selinux"
376 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
377 ;;
378esac
379
380# We always need the aqua useflag because otherwise we cannot = refer to it inside
381# add_kdebase_dep. This was always kind of a bug, but came to light with EAPI=5
382# (where referring to a use flag not in IUSE masks the ebuild).
383# The only alternative would be to prohibit using add_kdebase_dep if KDE_REQUIRED=never
384IUSE+=" aqua"
385
398case ${KDE_REQUIRED} in 386case ${KDE_REQUIRED} in
399 always) 387 always)
400 IUSE+=" aqua"
401 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}" 388 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
402 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}" 389 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
403 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}" 390 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
404 ;; 391 ;;
405 optional) 392 optional)
406 IUSE+=" aqua kde" 393 IUSE+=" kde"
407 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )" 394 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
408 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )" 395 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
409 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )" 396 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
410 ;; 397 ;;
411 *) ;; 398 *) ;;
420# Accumulate dependencies set by this eclass 407# Accumulate dependencies set by this eclass
421DEPEND+=" ${COMMONDEPEND}" 408DEPEND+=" ${COMMONDEPEND}"
422RDEPEND+=" ${COMMONDEPEND}" 409RDEPEND+=" ${COMMONDEPEND}"
423unset COMMONDEPEND 410unset COMMONDEPEND
424 411
425# Add experimental kdeenablefinal, masked by default
426IUSE+=" kdeenablefinal"
427
428# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 412# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
429# koffice ebuild, the URI should be set in the ebuild itself 413# kdevelop ebuild, the URI should be set in the ebuild itself
430_calculate_src_uri() { 414_calculate_src_uri() {
431 debug-print-function ${FUNCNAME} "$@" 415 debug-print-function ${FUNCNAME} "$@"
432 416
433 local _kmname _kmname_pv 417 local _kmname _kmname_pv
434 418
435 # we calculate URI only for known KDEBASE modules 419 # we calculate URI only for known KDEBASE modules
436 [[ -n ${KDEBASE} ]] || return 420 [[ -n ${KDEBASE} ]] || return
437 421
438 # calculate tarball module name 422 # calculate tarball module name
439 if [[ -n ${KMNAME} ]]; then 423 if [[ -n ${KMNAME} ]]; then
440 # fixup kdebase-apps name
441 case ${KMNAME} in
442 kdebase-apps)
443 _kmname="kdebase" ;;
444 *)
445 _kmname="${KMNAME}" ;; 424 _kmname="${KMNAME}"
446 esac
447 else 425 else
448 _kmname=${PN} 426 _kmname=${PN}
449 fi 427 fi
450 _kmname_pv="${_kmname}-${PV}" 428 _kmname_pv="${_kmname}-${PV}"
451 case ${KDEBASE} in 429 case ${KDEBASE} in
452 kde-base) 430 kde-base)
453 case ${PV} in 431 case ${PV} in
454 4.[456].8[05] | 4.[456].9[023568]) 432 4.4.11.1)
433 # KDEPIM 4.4, special case
434 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
435 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
436 4.?.[6-9]? | 4.??.[6-9]?)
455 # Unstable KDE SC releases 437 # Unstable KDE SC releases
438 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
439 4.[1-7].[12345])
440 # Stable KDE SC with old .bz2 support
456 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" 441 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
457 # KDEPIM IS SPECIAL 442 4.11.9)
458 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2" 443 # Part of 4.12 actually, sigh. Not stable for next release!
459 ;;
460 4.4.[6789] | 4.4.1?*)
461 # Stable kdepim releases
462 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" 444 SRC_URI="mirror://kde/stable/4.12.5/src/${_kmname_pv}.tar.xz" ;;
463 ;; 445 4.11.11)
446 # Part of 4.13 actually, sigh. Not stable for next release!
447 SRC_URI="mirror://kde/stable/4.13.3/src/${_kmname_pv}.tar.xz" ;;
448 4.11.12)
449 # Part of 4.14 actually, sigh. Not stable for next release!
450 SRC_URI="mirror://kde/stable/4.14.1/src/${_kmname_pv}.tar.xz" ;;
451 4.11.13)
452 # Part of 4.14 actually, sigh. Not stable for next release!
453 SRC_URI="mirror://kde/stable/4.14.2/src/${_kmname_pv}.tar.xz" ;;
454 4.11.14)
455 # Part of 4.14 actually, sigh. Not stable for next release!
456 SRC_URI="mirror://kde/stable/4.14.3/src/${_kmname_pv}.tar.xz" ;;
464 *) 457 *)
465 # Stable KDE SC releases 458 # Stable KDE SC releases
466 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" 459 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
467 ;;
468 esac 460 esac
469 ;; 461 ;;
470 koffice) 462 kdevelop|kdevelop-php*|kdevplatform)
471 case ${PV} in 463 case ${KDEVELOP_VERSION} in
472 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 464 4.[123].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
473 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 465 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
474 esac 466 esac
475 ;;
476 kdevelop)
477 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
478 ;; 467 ;;
479 esac 468 esac
480} 469}
481 470
482_calculate_live_repo() { 471_calculate_live_repo() {
486 case ${KDE_SCM} in 475 case ${KDE_SCM} in
487 svn) 476 svn)
488 # Determine branch URL based on live type 477 # Determine branch URL based on live type
489 local branch_prefix 478 local branch_prefix
490 case ${PV} in 479 case ${PV} in
491 9999*) 480 4.9999*)
492 # trunk 481 # trunk
493 branch_prefix="trunk/KDE" 482 branch_prefix="trunk/KDE"
494 ;; 483 ;;
495 *) 484 *)
496 # branch 485 # branch
497 branch_prefix="branches/KDE/${SLOT}" 486 branch_prefix="branches/KDE/$(get_kde_version)"
498 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX 487 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
499 # @DESCRIPTION 488 # @DESCRIPTION
500 # Suffix appended to ESVN_PROJECT depending on fetched branch. 489 # Suffix appended to ESVN_PROJECT depending on fetched branch.
501 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise. 490 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
502 ESVN_PROJECT_SUFFIX="-${PV}" 491 ESVN_PROJECT_SUFFIX="-${PV}"
535 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta 524 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
536 # build packages from same svn location. 525 # build packages from same svn location.
537 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 526 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
538 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 527 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
539 ;; 528 ;;
540 koffice)
541 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
542 ;;
543 *) 529 *)
544 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 530 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
545 ;; 531 ;;
546 esac 532 esac
547 else 533 else
550 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 536 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
551 fi 537 fi
552 # @ECLASS-VARIABLE: ESVN_UP_FREQ 538 # @ECLASS-VARIABLE: ESVN_UP_FREQ
553 # @DESCRIPTION: 539 # @DESCRIPTION:
554 # This variable is used for specifying the timeout between svn synces 540 # This variable is used for specifying the timeout between svn synces
555 # for kde-base and koffice modules. Does not affect misc apps. 541 # for kde-base modules. Does not affect misc apps.
556 # Default value is 1 hour. 542 # Default value is 1 hour.
557 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 543 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
558 ;; 544 ;;
559 git) 545 git)
560 local _kmname 546 local _kmname
561 # @ECLASS-VARIABLE: EGIT_MIRROR 547 # @ECLASS-VARIABLE: EGIT_MIRROR
562 # @DESCRIPTION: 548 # @DESCRIPTION:
576 else 562 else
577 _kmname=${PN} 563 _kmname=${PN}
578 fi 564 fi
579 565
580 # default branching 566 # default branching
581 case ${PV} in 567 [[ ${PV} != 4.9999* && ${KDEBASE} == kde-base ]] && \
582 9999*) ;; 568 EGIT_BRANCH="KDE/$(get_kde_version)"
583 *)
584 # set EGIT_BRANCH and EGIT_COMMIT to ${SLOT}
585 case ${_kmname} in
586 kdeplasma-addons | kdepim | kdepim-runtime | kdepimlibs | okular)
587 EGIT_BRANCH="${SLOT}"
588 ;;
589 marble)
590 EGIT_BRANCH="kde-${SLOT}"
591 ;;
592 *) EGIT_BRANCH="KDE/${SLOT}" ;;
593 esac
594 ;;
595 esac
596 569
570 # default repo uri
597 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}" 571 EGIT_REPO_URI+=( "${EGIT_MIRROR}/${_kmname}" )
598 572
599 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}" 573 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
600 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}" 574 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
601 ;; 575 ;;
602 esac 576 esac
603} 577}
604 578
605case ${BUILD_TYPE} in 579case ${KDE_BUILD_TYPE} in
606 live) _calculate_live_repo ;; 580 live) _calculate_live_repo ;;
607 *) _calculate_src_uri ;; 581 *) _calculate_src_uri ;;
608esac 582esac
609 583
610debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 584debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
611 585
612# @ECLASS-VARIABLE: PREFIX 586# @ECLASS-VARIABLE: PREFIX
613# @DESCRIPTION: 587# @DESCRIPTION:
614# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 588# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
615# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 589# kde-base packages go into KDE4 installation directory (/usr).
616# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 590# No matter the PREFIX, package will be built against KDE installed in /usr.
617 591
618# @FUNCTION: kde4-base_pkg_setup 592# @FUNCTION: kde4-base_pkg_setup
619# @DESCRIPTION: 593# @DESCRIPTION:
620# Do the basic KDEDIR settings and determine with which kde should 594# Do some basic settings
621# optional applications link
622kde4-base_pkg_setup() { 595kde4-base_pkg_setup() {
623 debug-print-function ${FUNCNAME} "$@" 596 debug-print-function ${FUNCNAME} "$@"
624 597
625 if has kdeprefix ${IUSE//+} && use kdeprefix; then 598 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
626 eerror "Sorry, kdeprefix support has been removed." 599 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
627 eerror "Please remove kdeprefix from your USE variable." 600 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
628 die "kdeprefix support has been removed"
629 fi 601 fi
630
631 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
632 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
633 has_version kde-base/kdelibs[kdeprefix]; then
634 eerror "Sorry, kdeprefix support has been removed."
635 eerror "Please rebuild kdelibs without kdeprefix support."
636 die "kdeprefix support has been removed"
637 fi
638
639 # QA ebuilds
640 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})."
641 602
642 # Don't set KDEHOME during compilation, it will cause access violations 603 # Don't set KDEHOME during compilation, it will cause access violations
643 unset KDEHOME 604 unset KDEHOME
644 605
645 # Check if gcc compiler is fresh enough. 606 # Check if gcc compiler is fresh enough.
646 # In theory should be in pkg_pretend but we check it only for kdelibs there 607 # In theory should be in pkg_pretend but we check it only for kdelibs there
647 # and for others we do just quick scan in pkg_setup because pkg_pretend 608 # and for others we do just quick scan in pkg_setup because pkg_pretend
648 # executions consume quite some time. 609 # executions consume quite some time (ie. when merging 300 packages at once will cause 300 checks)
610 if [[ ${MERGE_TYPE} != binary ]]; then
649 [[ $(gcc-major-version) -lt 4 ]] || \ 611 [[ $(gcc-major-version) -lt 4 ]] || \
650 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \ 612 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 6 ]] ) \
651 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)." 613 && die "Sorry, but gcc-4.6 and earlier wont work for some KDE packages."
614 fi
652 615
653 KDEDIR=/usr 616 KDEDIR=/usr
654 : ${PREFIX:=/usr} 617 : ${PREFIX:=/usr}
655 EKDEDIR=${EPREFIX}/usr 618 EKDEDIR=${EPREFIX}/usr
656 619
657 # Point pkg-config path to KDE *.pc files
658 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
659 # Point to correct QT plugins path 620 # Point to correct QT plugins path
660 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/" 621 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
661 622
662 # Fix XDG collision with sandbox 623 # Fix XDG collision with sandbox
663 export XDG_CONFIG_HOME="${T}" 624 export XDG_CONFIG_HOME="${T}"
664} 625}
665 626
667# @DESCRIPTION: 628# @DESCRIPTION:
668# This function unpacks the source tarballs for KDE4 applications. 629# This function unpacks the source tarballs for KDE4 applications.
669kde4-base_src_unpack() { 630kde4-base_src_unpack() {
670 debug-print-function ${FUNCNAME} "$@" 631 debug-print-function ${FUNCNAME} "$@"
671 632
672 if [[ ${BUILD_TYPE} = live ]]; then 633 if [[ ${KDE_BUILD_TYPE} = live ]]; then
673 case ${KDE_SCM} in 634 case ${KDE_SCM} in
674 svn) 635 svn)
675 migrate_store_dir
676 subversion_src_unpack 636 subversion_src_unpack
677 ;; 637 ;;
678 git) 638 git)
679 git-2_src_unpack 639 git-r3_src_unpack
680 ;; 640 ;;
681 esac 641 esac
682 else 642 else
683 unpack ${A} 643 unpack ${A}
684 fi 644 fi
701 fi 661 fi
702 662
703 # Enable/disable handbooks for kde4-base packages 663 # Enable/disable handbooks for kde4-base packages
704 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 664 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
705 # kdelibs inherits kde4-base but handle installing the handbook itself 665 # kdelibs inherits kde4-base but handle installing the handbook itself
706 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then 666 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
707 if [[ ${KDEBASE} == kde-base ]]; then 667 if [[ ${KDEBASE} == kde-base ]]; then
708 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then 668 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
709 # documentation in kde4-functions 669 # documentation in kde4-functions
710 : ${KDE_DOC_DIRS:=doc} 670 : ${KDE_DOC_DIRS:=doc}
711 local dir 671 local dir
721 enable_selected_doc_linguas 681 enable_selected_doc_linguas
722 fi 682 fi
723 fi 683 fi
724 684
725 # SCM bootstrap 685 # SCM bootstrap
726 if [[ ${BUILD_TYPE} = live ]]; then 686 if [[ ${KDE_BUILD_TYPE} = live ]]; then
727 case ${KDE_SCM} in 687 case ${KDE_SCM} in
728 svn) subversion_src_prepare ;; 688 svn) subversion_src_prepare ;;
729 esac 689 esac
730 fi 690 fi
731 691
732 # Apply patches 692 # Apply patches, cmake-utils does the job already
733 base_src_prepare 693 cmake-utils_src_prepare
734 694
735 # Save library dependencies 695 # Save library dependencies
736 if [[ -n ${KMSAVELIBS} ]] ; then 696 if [[ -n ${KMSAVELIBS} ]] ; then
737 save_library_dependencies 697 save_library_dependencies
738 fi 698 fi
740 # Inject library dependencies 700 # Inject library dependencies
741 if [[ -n ${KMLOADLIBS} ]] ; then 701 if [[ -n ${KMLOADLIBS} ]] ; then
742 load_library_dependencies 702 load_library_dependencies
743 fi 703 fi
744 704
745 # Replace KDE4Workspace library targets
746 find "${S}" -name CMakeLists.txt \
747 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
748 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
749 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
750 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
751 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
752 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
753 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
754 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
755 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
756 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
757 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
758 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
759 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
760 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
761 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
762 || die 'failed to replace KDE4Workspace library targets'
763
764 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/... 705 # Hack for manuals relying on outdated DTD, only outside kde-base/...
765 if [[ -z ${KDEBASE} ]]; then 706 if [[ -z ${KDEBASE} ]]; then
766 find "${S}" -name "*.docbook" \ 707 find "${S}" -name "*.docbook" \
767 -exec sed -i -r \ 708 -exec sed -i -r \
768 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \ 709 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
769 || die 'failed to fix DocBook variant version' 710 || die 'failed to fix DocBook variant version'
777 debug-print-function ${FUNCNAME} "$@" 718 debug-print-function ${FUNCNAME} "$@"
778 719
779 # Build tests in src_test only, where we override this value 720 # Build tests in src_test only, where we override this value
780 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF) 721 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
781 722
782 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then 723 if use_if_iuse debug; then
783 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
784 fi
785
786 if has debug ${IUSE//+} && use debug; then
787 # Set "real" debug mode 724 # Set "real" debug mode
788 CMAKE_BUILD_TYPE="Debugfull" 725 CMAKE_KDE_BUILD_TYPE="Debugfull"
789 else 726 else
790 # Handle common release builds 727 # Handle common release builds
791 append-cppflags -DQT_NO_DEBUG 728 append-cppflags -DQT_NO_DEBUG
792 fi 729 fi
793 730
798 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}") 735 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
799 736
800 # Use colors 737 # Use colors
801 QTEST_COLORED=1 738 QTEST_COLORED=1
802 739
803 # Shadow existing /usr installations 740 # Shadow existing installations
804 unset KDEDIRS 741 unset KDEDIRS
805 742
806 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling 743 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
807 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4) 744 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
808 #kde-config -path data unavailable when cross-compiling 745 #kde-config -path data unavailable when cross-compiling
810 747
811 # sysconf needs to be /etc, not /usr/etc 748 # sysconf needs to be /etc, not /usr/etc
812 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc) 749 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
813 750
814 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then 751 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
752 if [[ ${mycmakeargs} ]]; then
753 eqawarn "mycmakeargs should always be declared as an array, not a string"
754 fi
815 mycmakeargs=(${mycmakeargs}) 755 mycmakeargs=(${mycmakeargs})
816 fi 756 fi
817 757
818 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}") 758 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
819 759
832# @FUNCTION: kde4-base_src_test 772# @FUNCTION: kde4-base_src_test
833# @DESCRIPTION: 773# @DESCRIPTION:
834# Function for testing KDE4 applications. 774# Function for testing KDE4 applications.
835kde4-base_src_test() { 775kde4-base_src_test() {
836 debug-print-function ${FUNCNAME} "$@" 776 debug-print-function ${FUNCNAME} "$@"
777
778 local kded4_pid
779
780 _test_runner() {
781 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
782 export $(dbus-launch)
783 kded4 2>&1 > /dev/null &
784 kded4_pid=$!
785 fi
786
787 cmake-utils_src_test
788 }
789
790 # When run as normal user during ebuild development with the ebuild command, the
791 # kde tests tend to access the session DBUS. This however is not possible in a real
792 # emerge or on the tinderbox.
793 # > make sure it does not happen, so bad tests can be recognized and disabled
794 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
837 795
838 # Override this value, set in kde4-base_src_configure() 796 # Override this value, set in kde4-base_src_configure()
839 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON) 797 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
840 cmake-utils_src_configure 798 cmake-utils_src_configure
841 kde4-base_src_compile 799 kde4-base_src_compile
842
843 # When run as normal user during ebuild development with the ebuild command, the
844 # kde tests tend to access the session DBUS. This however is not possible in a real
845 # emerge or on the tinderbox.
846 # > make sure it does not happen, so bad tests can be recognized and disabled
847 unset DBUS_SESSION_BUS_ADDRESS
848 800
849 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then 801 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
850 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default 802 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
851 if [[ ${VIRTUALX_COMMAND} != emake ]]; then 803 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
852 # surprise- we are already INSIDE virtualmake!!! 804 # surprise- we are already INSIDE virtualmake!!!
853 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality." 805 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
854 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild." 806 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
855 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the" 807 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
856 debug-print " kde4-base.eclass docs for details... Applying workaround." 808 debug-print " kde4-base.eclass docs for details... Applying workaround."
857 cmake-utils_src_test 809 _test_runner
858 else 810 else
859 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake 811 VIRTUALX_COMMAND="_test_runner" virtualmake
860 fi 812 fi
861 else 813 else
862 cmake-utils_src_test 814 _test_runner
815 fi
816
817 if [ -n "${kded4_pid}" ] ; then
818 kill ${kded4_pid}
819 fi
820
821 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
822 kill ${DBUS_SESSION_BUS_PID}
863 fi 823 fi
864} 824}
865 825
866# @FUNCTION: kde4-base_src_install 826# @FUNCTION: kde4-base_src_install
867# @DESCRIPTION: 827# @DESCRIPTION:
884 done 844 done
885 fi 845 fi
886 846
887 cmake-utils_src_install 847 cmake-utils_src_install
888 848
889 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed, 849 # We don't want ${PREFIX}/share/doc/HTML to be compressed,
890 # because then khelpcenter can't find the docs 850 # because then khelpcenter can't find the docs
891 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] && 851 [[ -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
892 docompress -x ${PREFIX}/share/doc/HTML 852 docompress -x ${PREFIX}/share/doc/HTML
893} 853}
894 854
895# @FUNCTION: kde4-base_pkg_preinst 855# @FUNCTION: kde4-base_pkg_preinst
896# @DESCRIPTION: 856# @DESCRIPTION:
897# Function storing icon caches 857# Function storing icon caches
898kde4-base_pkg_preinst() { 858kde4-base_pkg_preinst() {
899 debug-print-function ${FUNCNAME} "$@" 859 debug-print-function ${FUNCNAME} "$@"
900 860
901 gnome2_icon_savelist 861 gnome2_icon_savelist
862 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
863 subversion_pkg_preinst
864 fi
902} 865}
903 866
904# @FUNCTION: kde4-base_pkg_postinst 867# @FUNCTION: kde4-base_pkg_postinst
905# @DESCRIPTION: 868# @DESCRIPTION:
906# Function to rebuild the KDE System Configuration Cache after an application has been installed. 869# Function to rebuild the KDE System Configuration Cache after an application has been installed.
911 fdo-mime_desktop_database_update 874 fdo-mime_desktop_database_update
912 fdo-mime_mime_database_update 875 fdo-mime_mime_database_update
913 buildsycoca 876 buildsycoca
914 877
915 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 878 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
916 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
917 echo
918 ewarn "WARNING! you have kdeenable final useflag enabled."
919 ewarn "This useflag needs to be enabled on ALL kde using packages and"
920 ewarn "is known to cause issues."
921 ewarn "You are using this setup at your own risk and the kde team does not"
922 ewarn "take responsibilities for dead kittens."
923 echo
924 fi
925 if [[ ${BUILD_TYPE} = live ]]; then 879 if [[ ${KDE_BUILD_TYPE} = live ]]; then
926 echo 880 echo
927 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}" 881 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
928 einfo "Use it at your own risk." 882 einfo "Use it at your own risk."
929 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!" 883 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
930 echo 884 echo
953 gnome2_icon_cache_update 907 gnome2_icon_cache_update
954 fdo-mime_desktop_database_update 908 fdo-mime_desktop_database_update
955 fdo-mime_mime_database_update 909 fdo-mime_mime_database_update
956 buildsycoca 910 buildsycoca
957} 911}
912
913fi

Legend:
Removed from v.1.96  
changed lines
  Added in v.1.143

  ViewVC Help
Powered by ViewVC 1.1.20